'' ============================================================
'' Solid Body Simulation Sampler - with gui interface
''
'' Copyright (C) 2006-2007 - Jeff Marshall (coder@execulink.com)
''
'' License: 1) Program is provided as-is.  
''          2) There is no warranty or guarantee.
''          3) There are no other conditions.
''
'' Feel free to use, re-use, or abuse :)
''
'' ============================================================
''
'' Requires FreeBasic Compiler
''
'' Compile using:
''   fbc atomsgui.bas atomseng.bas vector.bas dialog.bas
''
'' ============================================================

#ifndef __FB_LANG__
Option Explicit
#endif
const False = 0, True = Not False

#include "jm_gui/jm_gui.bi"
#include "atomseng.bi"
#include "dialog.bi"

'These variables are set by default, but may be changed here
'ATOMSIZE = 4
'ATOMSPACE = 10
'MAXSPEED = 5
'YGRAVITY = -.004
'XGRAVITY = 0
'BOUNDDECAY = 0.99
'DEFORMFACTOR = .4
'DEFORMTHRESHOLD = 1
'BREAKTHRESHOLD = 2
'STIFFNESS = 0.5
'BONDTHRESHOLD = 0.5  '' 0.2 was used in atom_stick.bas
'SHOWATOMS = 1
'SHOWBONDS = 1

dim as integer grabatom, mx, my, mw, mb, oldmb, i, j, ret, k
dim as single smx, smy, grabx, graby
dim as string skipframe

screen 18, 8, 2
UI_UpdateScreenInfo(640,480,8)
UI_SavePalette
screenset 1, 0

ReStart:

Randomize Timer
ClearAllAtoms

If (command(1)) > "" then
	i = 1
	while command(i) > ""
		LoadSettings command(i)	
		i += 1
	wend
else

	'' Various shapes
	'' Func X,Y,XSize,YSize,Color [, rotation]
	CreateBlock  100,  150,  2,  5, 14, 0.1
	CreateBlock    0,  150,  2,  5, 13, 0.1
	CreateTriBlock 0,  100,  7,     15, 0.1
	CreateBlock -100,  150,  3,  3, 12, 0.1
	CreateBlock    0, 2000,  5,  5, 11, 0.1
	CreateBlock -100, 1000, 10,  3, 10, 0.1
	CreateBlock -100,  500, 10,  8,  9, 0.1
	CreateBlock -150, 3000,  5,  5, 11, 0.1
	CreateBlock -200,  500, 20,  1,  7, 0.2

	'' Create from a bitmap
	'                  filename  ,  w,  h,    x, y             , rotate
	'CreateBlockFromBmp "man.bmp", 13, 18, -100, 64 * ATOMSPACE, 0.1
	'CreateBlockFromBmp "man.bmp", 13, 18,    0, 48 * ATOMSPACE, 0.1
	'CreateBlockFromBmp "man.bmp", 13, 18,  100, 32 * ATOMSPACE, 0.1

end if

'UI_RestorePalette

grabatom = 0

gOptQuit = 0
gOptRestart = 0

while gOptQuit = 0
  k = GetKeyCode
  oldmb = mb
  GetMouse mx, my, mw, mb
  smx = mx - 320
  smy = 480 - my
	ret = UI_UpdateMouseInfo(NULL, mx, my, mw, mb)
	if ret = 0 then
		if mb <> 0 and oldmb = 0 then
			grabatom = FindAtom(smx, smy)
		elseif mb = 0 then
			grabatom = 0
		end if

		if grabatom > 0 then
			if a(grabatom).ex = TRUE then
				a(grabatom).v.x = smx - a(grabatom).p.x
				a(grabatom).v.y = smy - a(grabatom).p.y
				if (mb and 2) then
					for i = 1 to NBONDS
						if b(i).a1 = grabatom then
							a(b(i).a2).v = a(grabatom).v
						elseif b(i).a2 = grabatom then
							a(b(i).a1).v = a(grabatom).v
						end if
					next i
				end if
			else
				grabatom = 0
			end if
		end if
	end if
	if k <> KEY_NONE then
		ret = UI_UpdateKeyInfo(NULL, k)
		if ret <> 0 then
			if k = 32 then '' SPACE
				for i = 1 TO NATOMS
					if a(i).ex = TRUE then
						VSet a(i).v, (rnd - 0.5) * MAXSPEED * 2, (rnd - 0.5) * MAXSPEED * 2
					end if
				next i
			end if
		end if
	end if
	if Multikey(1) then '' ESC
		OptionsDlg_Show
	end if
	if gOptRestart then
		goto Restart
	end if

	UpdateAtoms  

	cls
  DrawAtoms
	ret = UI_Draw(NULL, 0)
  'screensync
  flip

wend

UI_Close

screen 0
end
