'' ============================================================
'' 2D Vector Functions
''
'' Copyright (C) 2006-2007 - Jeff Marshall (coder@execulink.com)
''
'' License: 1) Program is provided as-is.  
''          2) There is no warranty or guarantee.
''          3) There are no other conditions.
''
'' Feel free to use, re-use, or abuse :)
''
'' ============================================================

#ifndef __FB_LANG__
Option Explicit
#endif

#include "vector.bi"

sub VAdd (byref v AS Vector, byref a AS Vector, byref b AS Vector)
  v.x = a.x + b.x
  v.y = a.y + b.y
end sub
sub VAdd2V (byref v AS Vector, byref a AS Vector)
  v.x = v.x + a.x
  v.y = v.y + a.y
end sub
sub VAddComp (byref v AS Vector, byref a AS Vector, byref x as single, byref y as single)
  v.x = a.x + x
  v.y = a.y + y
end sub
sub VAddComp2V ( byref v AS Vector, byref x as single, byref y as single)
  v.x = v.x + x
  v.y = v.y + y
end sub
sub VAddMul ( byref v AS Vector, byref k1 as single, byref a AS Vector, byref k2 as single, byref b AS Vector)
  v.x = k1 * a.x + k2 * b.x
  v.y = k1 * a.y + k2 * b.y
end sub
function VDist ( byref a AS Vector, byref b AS Vector) as single
  dim v AS Vector
  VSub v, a, b
  VDist = VMag(v)
end function
sub VLimit2V ( byref v AS Vector, byref d as single)
  if v.x > d then v.x = d
  if v.x < -d then v.x = -d
  if v.y > d then v.y = d
  if v.y < -d then v.y = -d
end sub
function VMag ( byref v AS Vector) as single
  VMag = SQR(v.x * v.x + v.y * v.y)
end function
sub VNeg ( byref v AS Vector, byref a AS Vector)
  VScale v, a, -1
end sub
sub VNeg2V ( byref v AS Vector)
  VScale2V v, -1
end sub
sub VScale ( byref v AS Vector, byref a AS Vector, byref k as single)
  v.x = k * a.x
  v.y = k * a.y
end sub
sub VScale2V ( byref v AS Vector, byref k as single)
  v.x = k * v.x
  v.y = k * v.y
end sub
sub VSet ( byref v AS Vector, byref x as single, byref y as single)
  v.x = x
  v.y = y
end sub
sub VSub ( byref v AS Vector, byref a AS Vector, byref b AS Vector)
  v.x = a.x - b.x
  v.y = a.y - b.y
end sub
sub VSub2V ( byref v AS Vector, byref a AS Vector)
  v.x = v.x - a.x
  v.y = v.y - a.y
end sub
sub VSubComp ( byref v AS Vector, byref a AS Vector, byref x as single, byref y as single)
  v.x = a.x - x
  v.y = a.y - y
end sub


sub VRot2V ( byref v AS Vector, byref r as single)
  dim a AS Vector
  a.x = v.x * COS(r) + v.y * SIN(r)
  a.y = -v.x * SIN(r) + v.y * COS(r)
  v = a
end sub
sub VRot902V ( byref v AS Vector)
  dim a AS Vector
  a = v
  v.x = -a.y
  v.y = a.x
end sub
